#! /bin/bash -x

function killforward {
    kill $KUBEPID
}

failureCode() {
    local code=${2:-500}
    local status=$(curl --head --location --connect-timeout 5 --write-out %{http_code} --silent --output /dev/null localhost:${LOCALPORT})
    [[ $status == ${code} ]] || [[ $status == 000 ]]
}


LOCALPORT=${LOCALPORT:-8888}

kubectl wait --timeout=2m pod -l app=varnish-ingress,example!=cli-args --for=delete

set -e
kubectl wait --timeout=2m pod -l example=cli-args --for=condition=Ready

kubectl port-forward svc/varnish-ingress ${LOCALPORT}:80 >/dev/null &
KUBEPID=$!
trap killforward EXIT

for ((n = 0; n < 20; n++)); do
  if [[ failureCode ]] ; then
    sleep 0.5
  fi
    break
done
varnishtest ${TESTOPTS} -Dlocalport=${LOCALPORT} cafe_cli-args.vtc

